/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mnenhy.                                    
 *                                                                 
 * The Initial Developer of the Original Code is Karsten Duesterloh.
 *                                                                 
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.                     
 *                                                                 
 * Contributor(s):                                                 
 *  Karsten Duesterloh <mnenhy@tprac.de>                            
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
// +-
// |    mnenhy-mailWindowOverlay.js
// |
// |    Written, forged, copied and conceived by Karsten Duesterloh <mnenhy@tprac.de>
// +-
// |    History:
// |    
// |    2002-12-15      View->Headers->Custom
// |    2002-12-20      View->Headers->Brief
// |    2003-01-06      RDF, no header view, multi custom views, brief view canceled
// +-

function InitViewHeadersMenu()
{
  // clear menulist
  var mnenhyPopup = document.getElementById("mnenhyMenupopupViewheadersmenu");
  for (var i = 0; i < mnenhyPopup.childNodes.length;)
  {
    var oItem0 = mnenhyPopup.childNodes[i];
    if (!oItem0.id.indexOf("mnenhyViewCustom"))
      mnenhyPopup.removeChild(oItem0);
    else
      ++i;
  }

  // create all custom header entries
  var iLists = CustomHeaderViewCount();
  if (iLists)
  {
    var sep = document.createElement("menuseparator");
    sep.setAttribute("id", "mnenhyViewCustomSep");
    mnenhyPopup.appendChild(sep);

    var iCnt = 0, j = 0;
    while ((iCnt < iLists) && (j < 100))  // bounding j to 100 is actually very bad :(
    {
      var cvname = CustomViewName(j);
      if (cvname && cvname.length)
      {
        var oItem = document.createElement("menuitem");
        oItem.setAttribute("id",        "mnenhyViewCustom"+j);
        oItem.setAttribute("type",      "radio");
        oItem.setAttribute("name",      "viewheadergroup");
        oItem.setAttribute("label",     cvname);
        oItem.setAttribute("accesskey", cvname[0]);
        oItem.setAttribute("oncommand", "MnenhyMsgViewHeaders("+(cViewCustomBase + j)+");");
        mnenhyPopup.appendChild(oItem);
        ++iCnt;
      }
      ++j;
    }
  }

  // select current item
  var id = null;
  var iHdrMode = GetHeaderView();

  if (iHdrMode >= cViewCustomBase)
  {
    id = "mnenhyViewCustom" + (iHdrMode - cViewCustomBase);
  }
  else
  {
    switch (iHdrMode)
    {
      // new non custom modes
      case cViewBriefHeaders:
        id = "mnenhyViewBriefHeaders";
        break;
      case cViewNoHeaders:
        id = "mnenhyViewNoHeaders";
        break;

      // old modes
      case cViewAllHeaders:
        id = "mnenhyViewAllHeaders";
        break;
      case cViewNormalHeaders:
      default:
        id = "mnenhyViewNormalHeaders";
        break;
    }
  }

  var menuitem = document.getElementById(id);
  if (menuitem)
      menuitem.setAttribute("checked", "true");
}


function MnenhyMsgViewHeaders(mode)
{
  SetHeaderView(mode);
  MsgReload();
  return true;
}